{ ஫  ৥  ஫}
uses Graph;
label 0,1;
var Mat,mx,my:integer;
var Start:boolean;
    Newx,Newy:integer;

procedure Init;
var grDriver,grMode,ErrCode: Integer;
begin
 grDriver := Detect;
 InitGraph(grDriver, grMode,' ');
 ErrCode := GraphResult;
 if ErrCode <> grOk then begin
  writeln ('Graphics error!');
  halt (1);
 end;
 mx:=Getmaxx; my:=Getmaxy;
end;

var sizex,sizey,startx,starty,i,j:integer;
var Wkx,Wky,Bkx,Bky,Wqx,Wqy:integer; {न 䨣}

procedure Draw; {㥬 }
var s:string;
begin
     sizex:=mx div 10; sizey:=my div 10;
     startx:=sizex; starty:=sizey;
     setcolor (CYAN);
     for i:=1 to 9 do begin
      line (startx,starty,startx,my-sizey);
      Str (i,s);
      if i<9 then outtextxy (startx+sizex div 2,starty-sizey div 2, s);
      startx:=startx+sizex;
     end; startx:=sizex;
     for i:=1 to 9 do begin
      line (startx,starty,mx-sizex,starty);
      Str (i,s);
      if i<9 then outtextxy (startx-sizex div 2, starty+sizey div 2, s);
      starty:=starty+sizey;
     end; starty:=sizey;
     for i:=1 to 8 do
     for j:=1 to 8 do begin
         if ((i+j) mod 2)=0 then setfillstyle (SolidFill, BLACK)
         else setfillstyle (SolidFill, WHITE);
         floodfill (startx+(i-1)*sizex + sizex div 2,
                    starty+(j-1)*sizey + sizey div 2, CYAN);
     end;
end;

procedure Figures;
begin
     SetTextStyle(DefaultFont, HorizDir, 3);
     setcolor (BROWN);
     outtextxy (startx+sizex*(Bkx-1)+sizex div 2,
               starty+sizey*(Bky-1)+sizey div 2,'K');
     setcolor (YELLOW);
     outtextxy (startx+sizex*(Wkx-1)+sizex div 2,
               starty+sizey*(Wky-1)+sizey div 2,'K');
     outtextxy (startx+sizex*(Wqx-1)+sizex div 2,
               starty+sizey*(Wqy-1)+sizey div 2,'*');
end;

function BetWeen (a,x,b:integer):boolean;
var Lo,Hi:integer;
begin    {, ᫨ X  A  B}
      Lo:=0;
      if a>b then begin Lo:=b; Hi:=a end
      else if a<b then begin Lo:=a; Hi:=b; end;
      if (Lo<>0) and (x>Lo) and (x<Hi) then
      BetWeen:=TRUE
      else BetWeen:=FALSE;
end;

function Handicap (Oldx, Oldy, Kx, Ky, Newx, Newy :integer):boolean;
begin {⨭, ᫨ ஫ 蠥 室}
      if ((Newx=Kx) and (Newy=Ky)) or (
         (Between (Oldx,Kx,Newx)=TRUE) and (Between (Oldy,Ky,Newy)=TRUE) and
         (abs(Oldx-Kx)=abs(Oldy-Ky)) and (abs(Newx-Kx)=abs(Newy-Ky)) ) then
         Handicap:=TRUE
      else Handicap:=FALSE;

end;

function Sosedi (x1, y1, x2, y2 :integer):boolean;
begin {⨭, ᫨ 䨣  ᥤ }
  if  (abs(x1-x2)<2) and (abs(y1-y2)<2) then Sosedi:=TRUE
  else Sosedi:=FALSE;
end;

function GoodField (Oldx, Oldy, Newx, Newy :integer):boolean;
begin {⨭, ᫨ ⪠ ⨦  }
      if ( ((Oldx=Newx) and (Oldy<>Newy)) or
           ((Oldy=Newy) and (Oldx<>Newx)) or    { }
           (abs(Oldx-Newx)=abs(Oldy-Newy)) {}
         ) and {   ஫}
         (Handicap (Oldx,Oldy,Wkx,Wky,Newx,Newy)=FALSE) and
         (Handicap (Oldx,Oldy,Bkx,Bky,Newx,Newy)=FALSE) and
          (Sosedi (Bkx,Bky,Newx,Newy)=FALSE) { 諨  㦮 ஫}
      then GoodField:=TRUE
      else GoodField:=FALSE;
end;

function KingsOff (Wqx, Wqy, Wkx, Wky, Bkx, Bky:integer):boolean;
begin { ᫨ ஫ ࠧ}
     if (Between (Wkx,Wqx,Bkx)=TRUE) or (Between (Wky,Wqy,Bky)=TRUE)
     then  KingsOff:=TRUE
     else KingsOff:=FALSE;
end;

procedure Go (Who,Newx,Newy:integer);
begin
     if Who<>0 then begin {஫}
          Wkx:=Newx; Wky:=Newy;
     end
     else begin {}
          Wqx:=Newx; Wqy:=Newy;
     end;
end;

procedure First; { 室  - ࠧ ஫}
label 10;
var i,j:integer;
begin
     for i:=1 to 8 do begin  {ॡࠥ  ᪨}
       for j:=1 to 8 do begin
         if (GoodField (Wqx, Wqy, i, j)=TRUE) AND       {⪠ ⨦}
            (KingsOff (i, j, Wkx, Wky, Bkx, Bky)=TRUE)  {஫ ࠧ}
         then begin
              Go (0,i,j); goto 10;
         end;
       end;
     end;
10: end;

function Correctking (var oldx,oldy:integer;newx,newy:integer):Boolean;
begin {, ᫨ 室 ୮ ஫ ⨬}
     if (Sosedi (oldx,oldy,newx,newy)=TRUE) and { ᥤ }
        (Sosedi (newx,newy,Wkx,Wky)=FALSE) and {  㦮 ஫}
        (Sosedi (newx,newy,Wqx,Wqy)=FALSE) and {  㦮 }
        (((oldx=newx) and (oldy=newy)) =FALSE) and {   }
        (GoodField (newx,newy,Wqx,Wqy)=FALSE) {   }
        then begin  Oldx:=Newx; Oldy:=Newy; CorrectKing:=TRUE;
        end
        else CorrectKing:=FALSE;
end;

function GetSquare (Qx, Qy, Kx, Ky:integer):integer;
begin    {頤 㣫, ⠢襣  ஢ ஫}
     if Qx<Kx then begin
        if Qy>Ky then GetSquare:=(8-qx)*(qy-1)
        else if Qy<Ky then GetSquare:=(8-qx)*(8-qy)
        else GetSquare:=(8-qx)*8;
     end
     else if Qx>Kx then begin
         if Qy>Ky then GetSquare:=(qy-1)*(qx-1)
         else if Qy<Ky then GetSquare:=(qx-1)*(8-qy)
         else GetSquare:=(8-qy)*8;
     end
     else begin
          if Qy>Ky then GetSquare:=(qy-1)*8
          else GetSquare:=(8-qy)*8;
     end;
end;

function HorseHod (x1,y1,x2,y2: integer):boolean;
begin    {, ᫨ 䨣 ࠧ 室 }
     if (abs(x1-x2)=1) and (abs(y1-y2)=2) or
        (abs(x1-x2)=2) and (abs(y1-y2)=1) then HorseHod:=TRUE
     else HorseHod:=FALSE;
end;

function Dist (x1,y1,x2,y2:integer):integer;
begin    {ﭨ  ⪠}
     if abs(x1-x2)>abs(y1-y2) then Dist:=abs(x1-x2)
     else Dist:=abs(y1-y2);
end;

procedure KingGoalStep (goalx, goaly:integer);
 { ஫   楫 (qoalx,qoaly)}
var i,j,Newx,Newy:integer;
begin
       if (Sosedi (Wkx,Wky,goalx,goaly)=TRUE) then begin
          Wkx:=goalx; Wky:=goaly; Mat:=1;
       end
       else begin
         for i:=1 to 8 do begin
           for j:=1 to 8 do begin
               if (Sosedi (Wkx, Wky, i, j)=TRUE) and { ᥤ}
                  (Sosedi (i,j,Bkx,Bky)=FALSE) and {  㦮 ஫}
                  ( ((i=Wqx) and (j=Wqy))=FALSE) and {  }
                  ( ((i=Wkx) and (j=Wky))=FALSE) and
                  (Dist (i,j,goalx,goaly) < Dist (Wkx,Wky,goalx,goaly) )
               then begin
                    Newx:=i; Newy:=j;
               end;
           end;
         end;
         Wkx:=Newx; Wky:=Newy;
       end;
end;

procedure KingStep; {  ஫  ୮   㣮}
var i,j:integer;
begin
    if (Bkx<3) and (Bky<3) then begin { 孨 -  33}
       if Mat=1 then begin
          Wqx:=2; Wqy:=2; Mat:=2;
       end
       else KingGoalStep (3,3);
    end
    else if (Bkx<3) and (Bky>6) then begin {  -  36}
       if Mat=1 then begin
          Wqx:=2; Wqy:=7; Mat:=2;
       end
       else KingGoalStep (3,6);
    end
    else if (Bkx>6) and (Bky>3) then begin {ࠢ 孨 -  63}
       if Mat=1 then begin
          Wqx:=7; Wqy:=2; Mat:=2;
       end
       else KingGoalStep (6,3);
    end
    else begin { 66}
       if Mat=1 then begin
          Wqx:=7; Wqy:=7; Mat:=2;
       end
       else KingGoalStep (6,6);
    end;
end;

procedure Step;
var Square,MinSquare,i,j: integer;
begin {᭮ 蠣 ⬠}
      MinSquare:=64;
      if (GetSquare (Wqx,Wqy,Bkx,Bky)<4) then begin {  㣮}
         KingStep;
      end
      else begin
           for i:=1 to 8 do begin
               for j:=1 to 8 do begin

                   if (GoodField (Wqx, Wqy, i, j)=TRUE) and
                      ((HorseHod (i,j,Bkx,Bky)=TRUE) or
                      (GetSquare (i,j,Bkx,Bky)=3)) then begin
                      Square:=GetSquare (i,j,Bkx,Bky);
                      if Square<MinSquare then begin
                         Wqx:=i; Wqy:=j; Square:=MinSquare;
                      end;
                   end;
               end;
           end;
      end;
end;

begin { ணࠬ}
     Mat:=0; Start:=TRUE;
     Wkx:=7;Wky:=7;     Wqx:=1;Wqy:=8;     Bkx:=3;Bky:=3;
     while TRUE do begin
0:
          Init;
          Draw;
          Figures;
          Readln;
          if Start then begin First; Start:=FALSE; goto 0; end;
          closegraph;
          if Mat=2 then halt (0);
1:
          writeln;
          write (' 室 (x y)?');
          readln (Newx,Newy);
          if CorrectKing (Bkx,Bky,Newx,Newy)=FALSE then begin
             writeln ('Error!');
             goto 1;
          end;
          Step;
     end;
end.
{ 1 - Wkx:=7;Wky:=7;     Wqx:=1;Wqy:=8;     Bkx:=3;Bky:=3; - }
{ 2 - Wkx:=8;Wky:=1;     Wqx:=7;Wqy:=1;     Bkx:=4;Bky:=4; - OK}